//---------------------------------------------------------------------------

#include <vcl.h>
//#include <DBTables.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ZAbstractDataset"
#pragma link "ZAbstractRODataset"
#pragma link "ZConnection"
#pragma link "ZDataset"
#pragma link "ZSqlUpdate"
#pragma resource "*.dfm"
TMyDemoForm *MyDemoForm;
//---------------------------------------------------------------------------
__fastcall TMyDemoForm::TMyDemoForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMyDemoForm::ConnectClick(TObject *Sender)
{
  ZConnection1->Connect();
}
//---------------------------------------------------------------------------
void __fastcall TMyDemoForm::FormShow(TObject *Sender)
{
  MemoSQL->Lines->Assign(ZQuery1->SQL);
  ZQuery1->Fields->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::ExecQueryButtonClick(TObject *Sender)
{
  ZQuery1->ExecSQL();
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::OpenButtonClick(TObject *Sender)
{
  ZQuery1->Open();
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::CloseButtonClick(TObject *Sender)
{
  ZQuery1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::MemoSQLExit(TObject *Sender)
{
  if (MemoSQL->Lines->Text != ZQuery1->SQL->Text)
                  ZQuery1->SQL->Assign(MemoSQL->Lines);
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::FillComboButtonClick(TObject *Sender)
{
  ZQuery1->First();
  while (!ZQuery1->Eof)
    {
    ComboBox1->Items->Add(ZQuery1->FieldByName("id")->AsString);
    ZQuery1->Next();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::PrintLogButtonClick(TObject *Sender)
{
int  i;
AnsiString Temp;

  Temp="";
  for (i=0; i<ZQuery1->FieldCount; i++)
    {
    if (Temp !="")    Temp+=",";
    Temp+="'"+ ZQuery1->Fields->Fields[i]->DisplayName + "'";
    }
  memLog->Lines->Append(Temp);
  memLog->Lines->Append("------------------------------------------");

  ZQuery1->First();

  while (!ZQuery1->Eof)
    {
    Temp="";
    for (i=0; i<ZQuery1->FieldCount; i++)
      {
      if (Temp !="")    Temp+=",";
      Temp+="'"+ ZQuery1->Fields->Fields[i]->AsString + "'";
      }
    memLog->Lines->Append(Temp);
    ZQuery1->Next();
    }
   memLog->Lines->Append("");
}
//---------------------------------------------------------------------------


void __fastcall TMyDemoForm::ApplyupdatesButtonClick(TObject *Sender)
{
  ZQuery1->ApplyUpdates();
  ZQuery1->CommitUpdates();
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::CancelupdatesButtonClick(TObject *Sender)
{
  ZQuery1->CancelUpdates();
}
//---------------------------------------------------------------------------

void __fastcall TMyDemoForm::LoadImageButtonClick(TObject *Sender)
{
TStream * BlobStream;
TFileStream * FileStream;
  if (ZQuery1->Active && dlgOpenFile->Execute() )
    {
    if (ZQuery1->State != dsEdit)  ZQuery1->Edit();
    BlobStream=ZQuery1->CreateBlobStream( ZQuery1->FieldByName(edtBlobColumn->Text), bmWrite);
    try
      {
      FileStream=new TFileStream(dlgOpenFile->FileName, fmOpenRead);
      try
        {
        BlobStream->CopyFrom(FileStream, FileStream->Size);
        }
      __finally
        {
        delete FileStream;
        }
      }
    __finally
        {
        delete BlobStream;
        }
    }
    ZQuery1->Post();
}
//---------------------------------------------------------------------------


